<?php

namespace Leenooks\SQRL\SQRL;

use Leenooks\SQRL\SQRL;
use Leenooks\SQRL\Models\Pubkey as Model;

class Pubkey
{
	/**
	 * Check Pubkey exists from a previous session
	 *
	 * @param string $public_key
	 * @return Model|null
	 */
	public static function check(string $public_key): ?Model
	{
		return Model::where('public_key',SQRL::base64_encode_url($public_key))->first();
	}

	/**
	 * Store Public Key in DB
	 *
	 * @param $public_key
	 * @param $suk
	 * @param $vuk
	 * @return mixed
	 */
	public static function create(string $public_key,string $suk,string $vuk): Model
	{
		$o = new Model;
		$o->public_key = SQRL::base64_encode_url($public_key);
		$o->suk = SQRL::base64_encode_url($suk);
		$o->vuk = SQRL::base64_encode_url($vuk);

		$o->save();
		return $o;
	}
}
