<script>
	var syncQuery = window.XMLHttpRequest ? new window.XMLHttpRequest() : new ActiveXObject('MSXML2.XMLHTTP.3.0');
	var encodedSqrlUrl = false, sqrlScheme = true;
	var gifProbe = new Image(); 					// create an instance of a memory-based probe image
	var localhostRoot = 'http://localhost:25519/';	// the SQRL client listener
	const poll = 500;

	// define our load-success function
	gifProbe.onload = function() {
		sqrlScheme = false;							// prevent retriggering of the SQRL QR code.
		document.location.href = localhostRoot+encodedSqrlUrl;
	};

	// define our load-failure function
	gifProbe.onerror = function() {
		setTimeout(function() {
			gifProbe.src = localhostRoot+Date.now()+'.gif';
		},250);
	};

	// Poll to see if authentication has proceeded
	function pollForNextPage() {
		if (document.hidden) {					// before probing for any page change, we check to
			setTimeout(pollForNextPage,poll);	// see whether the page is visible. If the user is
			return;								// not viewing the page, check again in 5 seconds.
		}

		syncQuery.open('GET','{{ $check_state_on }}');				// the page is visible, so let's check for any update
		syncQuery.onreadystatechange = function() {
			if (syncQuery.readyState === 4 ) {
				if (syncQuery.status === 200 ) {

					var response = JSON.parse(syncQuery.response);

					if (response.isReady) {
						document.location.href = response.nextPage;

					} else {
						if (response.msg === "Invalid Nonce, or Nonce expired"
							|| response.msg === "IP Mismatch"
							|| response.msg === "SQRL disabled for user")
						{
							var div = document.getElementById('error_message');
							div.innerHTML = "<string>"+response.msg+"</strong><br><small>QR Code needs to be refresh - reload the page.<small>";
							div.removeAttribute("hidden");

						} else {
							setTimeout(pollForNextPage,poll);
						}
					}

				} else {
					setTimeout(pollForNextPage,poll);
				}
			}
		};

		// Send our request to check authenticated status
		syncQuery.send();
	}

	// if we have an encoded URL to jump to, initiate our GIF probing before jumping
	function sqrlLinkClick(e) {
		encodedSqrlUrl = e.getAttribute('encoded-sqrl-url');

		if (encodedSqrlUrl) {
			gifProbe.onerror();
		}
	}

	pollForNextPage();
</script>